import { Socket } from 'net';
import Request from './wrapper/Request';
import Response from './wrapper/Response';
export function readEnv(env, varName) {
    const uc = varName.toUpperCase();
    const lc = varName.toLowerCase();
    if (uc in env) {
        return env[uc];
    }
    else if (lc in env) {
        return env[lc];
    }
    return undefined;
}
export function hookStdout(stdout, stderr) {
    const write = stdout.write.bind(stdout);
    const end = stdout.end.bind(stdout);
    stdout.write = stderr.write.bind(stderr);
    stdout.end = stderr.end.bind(stderr);
    return Object.assign(Object.create(Socket.prototype), Object.assign(Object.assign({}, stdout), { write,
        end }));
}
export function hookExpressjsRequest(app) {
    if (!app.request) {
        return;
    }
    Object.setPrototypeOf(Request.prototype, Object.getPrototypeOf(app.request));
    app.request = Object.create(Request.prototype, {
        app: {
            configurable: true,
            enumerable: true,
            writable: true,
            value: app,
        },
    });
}
export function hookExpressjsResponse(app) {
    if (!app.response) {
        return;
    }
    Object.setPrototypeOf(Response.prototype, Object.getPrototypeOf(app.response));
    app.response = Object.create(Response.prototype, {
        app: {
            configurable: true,
            enumerable: true,
            writable: true,
            value: app,
        },
    });
}
