import { readEnv } from '../../utils';
const DEFAULT_VERSION = [1, 0];
export default function parseHttpVersion(env) {
    const serverProtocol = readEnv(env, 'SERVER_PROTOCOL');
    if (serverProtocol === undefined) {
        return DEFAULT_VERSION;
    }
    const ra = /^HTTP\/(\d+)(?:\.(\d+))?$/i.exec(serverProtocol);
    if (!ra) {
        return DEFAULT_VERSION;
    }
    return [Number(ra[1]), Number(ra[2])];
}
