import * as http from 'http';
export default class Response extends http.ServerResponse {
    constructor(req, stdout, endCallback) {
        super(req);
        this.endCallback = endCallback;
        this.useChunkedEncodingByDefault = false;
        this.assignSocket(stdout);
    }
    end(...args) {
        const endCallback = this.endCallback;
        super.end(...args);
        if (endCallback) {
            endCallback();
        }
    }
}
