"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.hookExpressjsResponse = exports.hookExpressjsRequest = exports.hookStdout = exports.readEnv = void 0;
const net_1 = require("net");
const Request_1 = require("./wrapper/Request");
const Response_1 = require("./wrapper/Response");
function readEnv(env, varName) {
    const uc = varName.toUpperCase();
    const lc = varName.toLowerCase();
    if (uc in env) {
        return env[uc];
    }
    else if (lc in env) {
        return env[lc];
    }
    return undefined;
}
exports.readEnv = readEnv;
function hookStdout(stdout, stderr) {
    const write = stdout.write.bind(stdout);
    const end = stdout.end.bind(stdout);
    stdout.write = stderr.write.bind(stderr);
    stdout.end = stderr.end.bind(stderr);
    return Object.assign(Object.create(net_1.Socket.prototype), Object.assign(Object.assign({}, stdout), { write,
        end }));
}
exports.hookStdout = hookStdout;
function hookExpressjsRequest(app) {
    if (!app.request) {
        return;
    }
    Object.setPrototypeOf(Request_1.default.prototype, Object.getPrototypeOf(app.request));
    app.request = Object.create(Request_1.default.prototype, {
        app: {
            configurable: true,
            enumerable: true,
            writable: true,
            value: app,
        },
    });
}
exports.hookExpressjsRequest = hookExpressjsRequest;
function hookExpressjsResponse(app) {
    if (!app.response) {
        return;
    }
    Object.setPrototypeOf(Response_1.default.prototype, Object.getPrototypeOf(app.response));
    app.response = Object.create(Response_1.default.prototype, {
        app: {
            configurable: true,
            enumerable: true,
            writable: true,
            value: app,
        },
    });
}
exports.hookExpressjsResponse = hookExpressjsResponse;
