"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const DEFAULT_VERSION = [1, 0];
function parseHttpVersion(env) {
    const serverProtocol = utils_1.readEnv(env, 'SERVER_PROTOCOL');
    if (serverProtocol === undefined) {
        return DEFAULT_VERSION;
    }
    const ra = /^HTTP\/(\d+)(?:\.(\d+))?$/i.exec(serverProtocol);
    if (!ra) {
        return DEFAULT_VERSION;
    }
    return [Number(ra[1]), Number(ra[2])];
}
exports.default = parseHttpVersion;
